/*************************************************
  FileName: xtxapp.h
  Authro: zhaoyongsheng
  Date: 2017.02.09
  Description:xtxapp for linux C API declare
*************************************************/
#ifndef _XTXAPP_C_UTIL_H_
#define _XTXAPP_C_UTIL_H_

#ifdef __cplusplus
extern "C" {
#endif

typedef struct sof_ctx_t sof_ctx_t;

#ifndef BASE_STRUCT
	#define BASE_STRUCT
	typedef unsigned int  uint32;
	typedef unsigned char uchar;
	typedef const uchar   kuchar;
	typedef const char    kchar;
#endif

#define SOF_API __attribute__((visibility ("default")))

/*
 * usbkey change event 
 */
enum {
	e_event_insert = 1,
	e_event_remove = 2,
};

/* 
 * usbkey change callback function prototype
 * @param ctx    : the context for callback, pass by SOF_InitializeEx
 * @param action : change event
 */
typedef void (ukey_change_cb_fn)(void* ctx, int action);

/***************************************************
 *  SOF_Initialize
 * ˵:ʼӦû,ӿǰҪȵñӿڻSOF_InitializeEx
 * ˵: 
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_Initialize(sof_ctx_t **sctx);

/***************************************************
 *  SOF_InitializeEx,ӿǰҪȵñӿڻSOF_Initialize
 * ˵:ʼӦûչ 豸ʱԵõص callback_f
 * ˵: callback_f [IN] صĵַָ
 *           ctx        [IN] صĵһ
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/ 
int SOF_API SOF_InitializeEx(sof_ctx_t **sctx, ukey_change_cb_fn *cb, void* ctx);

/***************************************************
 *  SOF_Finalize
 * ˵: Ӧû úӿڲܵ
 * ˵: 
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_Finalize(sof_ctx_t *sctx);

/***************************************************
 *  SOF_GetVersion
 * ˵: ȡ̬İ汾 
 * ˵: version     [OUT] ذ汾ŵĻز32ֽ
 *           version_len [IN]  ʾĳȣֹڴԽ
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_GetVersion(sof_ctx_t *sctx, char *version, uint32 ver_len);

/*
 * sign method
 */
enum {
	e_alg_sm3_rsa    = 0x00010001,
	e_alg_sha1_rsa   = 0x00010002,
	e_alg_sha256_rsa = 0x00010004,
	e_alg_sm3_sm2    = 0x00020101,
};

/***************************************************
 *  SOF_SetSignMethod
 * ˵: ǩ㷨
 * ˵: sign_algo [IN] ǩ㷨
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_SetSignMethod(sof_ctx_t *sctx, uint32 sign_algo);

/***************************************************
 *  SOF_GetSignMethod
 * ˵: ȡǩ㷨
 * ˵: sign_algo [OUT] ǩ㷨
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_GetSignMethod(sof_ctx_t *sctx, uint32 *sign_algo);

/*
 * encrypt method
 */
enum {
	e_alg_sm1_ecb = 0x00000101,
	e_alg_sm1_cbc = 0x00000102,
	e_alg_sm1_cfb = 0x00000104,
	e_alg_sm1_ofb = 0x00000108,
	
	e_alg_ssf33_ecb = 0x00000201,
	e_alg_ssf33_cbc = 0x00000202,
	e_alg_ssf33_cfb = 0x00000204,
	e_alg_ssf33_ofb = 0x00000208,
	
	e_alg_sm4_ecb = 0x00000401,
	e_alg_sm4_cbc = 0x00000402,
	e_alg_sm4_cfb = 0x00000404,
	e_alg_sm4_ofb = 0x00000408,
	
	// des key length 8
	e_alg_des_ecb = 0x00000801,
	e_alg_des_cbc = 0x00000802,
	e_alg_des_cfb = 0x00000804,
	e_alg_des_ofb = 0x00000808,	
	
	// des key length 16
	e_alg_des_ede_ecb = 0x00001001,
	e_alg_des_ede_cbc = 0x00001002,
	e_alg_des_ede_cfb = 0x00001004,
	e_alg_des_ede_ofb = 0x00001008,
	
	// des key length 24
	e_alg_des_ede3_ecb = 0x00002001,
	e_alg_des_ede3_cbc = 0x00002002,
	e_alg_des_ede3_cfb = 0x00002004,
	e_alg_des_ede3_ofb = 0x00002008,
	
	// aes key length 16
	e_alg_aes_128_ecb = 0x00004001,
	e_alg_aes_128_cbc = 0x00004002,
	e_alg_aes_128_cfb = 0x00004004,
	e_alg_aes_128_ofb = 0x00004008,
	
	// aes key length 24
	e_alg_aes_192_ecb = 0x00008001,
	e_alg_aes_192_cbc = 0x00008002,
	e_alg_aes_192_cfb = 0x00008004,
	e_alg_aes_192_ofb = 0x00008008,
	
	// aes key length 32
	e_alg_aes_256_ecb = 0x00010001,
	e_alg_aes_256_cbc = 0x00010002,
	e_alg_aes_256_cfb = 0x00010004,
	e_alg_aes_256_ofb = 0x00010008,
};

enum { 
	// ӽ
	e_encrypt = 0, 
	e_decrypt = 1, 

	// ䷽ʽ
	e_padding_none  = 0, 
	e_padding_pkcs5 = 1,

	//Գ㷨
	e_sm1_ecb = 0x00000101, 
	e_sm1_cbc = 0x00000102,
	e_sm1_cfb = 0x00000104,
	e_sm1_ofb = 0x00000108,
	e_sm1_mac = 0x00000110,

	e_ssf33_ecb = 0x00000201,
	e_ssf33_cbc = 0x00000202,
	e_ssf33_cfb = 0x00000204,
	e_ssf33_ofb = 0x00000210,

	e_sm4_ecb = 0x00000401,
	e_sm4_cbc = 0x00000402,
	e_sm4_cfb = 0x00000404,
	e_sm4_ofb = 0x00000408,
	e_sm4_mac = 0x00000410,

	//Զչ Գ㷨
	e_des_ecb = 0x00000801,
	e_des_cbc = 0x00000802,
	e_des_cfb = 0x00000804,
	e_des_ofb = 0x00000808,
	e_des_mac = 0x00000810,

	e_3des_2key_ecb = 0x00001001,
	e_3des_2key_cbc = 0x00001002,
	e_3des_2key_cfb = 0x00001004,
	e_3des_2key_ofb = 0x00001008,
	e_3des_2key_mac = 0x00001010,

	e_3des_3key_ecb = 0x00002001,
	e_3des_3key_cbc = 0x00002002,
	e_3des_3key_cfb = 0x00002004,
	e_3des_3key_ofb = 0x00002008,
	e_3des_3key_mac = 0x00002010,

	e_aes_128_ecb = 0x00004001,
	e_aes_128_cbc = 0x00004002,
	e_aes_128_cfb = 0x00004004,
	e_aes_128_ofb = 0x00004008,
	e_aes_128_mac = 0x00004010,

	e_aes_192_ecb = 0x00008001,
	e_aes_192_cbc = 0x00008002,
	e_aes_192_cfb = 0x00008004,
	e_aes_192_ofb = 0x00008008,
	e_aes_192_mac = 0x00008010,

	e_aes_256_ecb = 0x00010001,
	e_aes_256_cbc = 0x00010002,
	e_aes_256_cfb = 0x00010004,
	e_aes_256_ofb = 0x00010008,
	e_aes_256_mac = 0x00010010
};

/***************************************************
 *  SOF_SetEncryptMethod
 * ˵: ü㷨
 * ˵: enc_alog [IN] 㷨
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/ 
int SOF_API SOF_SetEncryptMethod(sof_ctx_t *sctx, uint32 enc_algo);

/***************************************************
 *  SOF_GetEncryptMethod
 * ˵: ȡ㷨
 * ˵: enc_alog [OUT] 㷨
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_GetEncryptMethod(sof_ctx_t *sctx, uint32 *enc_algo);

/***************************************************
 *  SOF_GetUserList
 * ˵: ȡûб
 * ˵: user_list     [OUT]    ظʽû1||CertID1&&&û2||CertID2&&&û3||CertID3&&&,'\0'β
 *           user_list_len [IN/OUT] ʱʾĳ ʱʾuser_listĳ '\0'
 * ֵ: 0ɹ 0ʧ 
 * ע 
 ***************************************************/
int SOF_API SOF_GetUserList(sof_ctx_t *sctx, char *user_list, uint32 *ul_len);

/***************************************************
 *  SOF_ExportUserCert
 * ˵: û֤ Ĭϵǩ֤ ǩ֤鵼֤
 * ˵: certid        [IN]     ֤ID,'\0'β
 *           user_cert     [OUT]    صder֤
 *           user_cert_len [IN/OUT] (user_certΪNULL)ʱʶĳ ʱʾuser_certĳ
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_ExportUserCert(sof_ctx_t *sctx, kchar *certid, 
                               uchar *user_cert, uint32 *uc_len);

/***************************************************
 *  SOF_ExportExChangeUserCert
 * ˵: û֤ Ĭϵ
 * ˵: certid        [IN]     ֤ID,'\0'β
 *           user_cert     [OUT]    صder֤
 *           user_cert_len [IN/OUT] (user_certΪNULL)ʱʶĳ ʱʾuser_certĳ
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_ExportExChangeUserCert(sof_ctx_t *sctx, kchar *certid, 
                                       uchar *user_cert, uint32 *uc_len);

/***************************************************
 *  SOF_Login
 * ˵: ¼ ֤֤
 * ˵: certid    [IN] ֤ID,'\0'β
 *           user_pass [IN] ֤,'\0'β
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_Login(sof_ctx_t *sctx, kchar *certid, kchar *user_pin);

/***************************************************
 *  SOF_IsLogin
 * ˵: жϵ¼ ֤ûǷ¼
 * ˵: certid    [IN] ֤ID,'\0'β       
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_IsLogin(sof_ctx_t *sctx,uchar * sDeviceSN);

/***************************************************
 *  SOF_Logout
 * ˵: ûǳ
 * ˵: certid [IN] ֤ID,'\0'β
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_Logout(sof_ctx_t *sctx, kchar *certid);

/***************************************************
 *  SOF_GetPinRetryCount
 * ˵: ȡ֤ʣԴ
 * ˵: certid     [IN]  ֤ID,'\0'β
 *           retrycount [OUT] ֤ʣԴ
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_GetPinRetryCount(sof_ctx_t *sctx, kchar *certid, uint32 *rc);

/***************************************************
 *  SOF_ChangePassWd
 * ˵: ޸֤
 * ˵: certid    [IN] ֤ID,'\0'β
 *           old_pass  [IN] ֤,'\0'β
 *           new_pass  [IN] ֤,'\0'β
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_ChangePassWd(sof_ctx_t *sctx, kchar *certid, kchar *old_pin, kchar *new_pin);


/*
 * get certificate type
 */
enum {
	e_cert_version = 1,
	e_cert_serialnumber = 2,
	e_cert_sign_method = 3,
	e_cert_issuer_c = 4,
	e_cert_issuer_o = 5,
	e_cert_issuer_ou = 6,
	e_cert_issuer_st = 7,
	e_cert_issuer_cn = 8,
	e_cert_issuer_l = 9,
	e_cert_issuer_e = 10,
	e_cert_valid_not_before = 11,
	e_cert_valid_not_after = 12,
	e_cert_subject_c = 13,
	e_cert_subject_o = 14,
	e_cert_subject_ou = 15,
	e_cert_subject_st = 16,
	e_cert_subject_cn = 17,
	e_cert_subject_l = 18,
	e_cert_subject_e = 19,
	e_cert_publickey = 20,
	e_cert_issuer_uid = 21,
	e_cert_subject_uid = 22,
	e_cert_key_usage = 23,
	e_cert_subject_dn = 33,
	e_cert_issuer_dn = 34,

	// Կ÷ʶ
	e_keyusage_none = 0,
	e_keyusage_sign = (1 << 0),
	e_keyusage_enc  = (1 << 1)
};

/***************************************************
 *  SOF_GetCertInfo
 * ˵: ȡ֤Ϣ
 * ˵: user_cert     [IN]     Der֤
 *           user_cert_len [IN]     Der֤鳤
 *           type          [IN]     Ϣ
 *           outd          [OUT]    Ϣ,NULLʱͨoutd_lenȡ
 *           outd_len      [IN/OUT] ʱ(outdΪNULL)ʾϢĻ
 *                                  ʱʾϢĳ
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_GetCertInfo(sof_ctx_t *sctx, kuchar *user_cert, uint32 uc_len, 
					        uint32 type, uchar *outd, uint32 *o_len);

/***************************************************
 *  SOF_GetCertInfoByOid
 * ˵: ͨOIDȡ֤չϢ
 * ˵: user_cert     [IN]     Der֤
 *           user_cert_len [IN]     Der֤鳤
 *           oid           [IN]     OID,'\0'β
 *           outd          [OUT]    Ϣ,NULLʱͨoutd_lenȡ
 *           outd_len      [IN/OUT] ʱ(outdΪNULL)ʾϢĻ
 *                                  ʱʾϢĳ
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_GetCertInfoByOid(sof_ctx_t *sctx, kuchar *user_cert, uint32 uc_len, 
						         kchar *oid, uchar *outd, uint32 *outd_len);

/***************************************************
 *  SOF_GetCertEntity
 * ˵: ȡ֤Ψһʵʶ
 * ˵: user_cert     [IN] Der֤
 *           user_cert_len [IN] Der֤鳤
 *           cert_entity     [OUT]    ֤Ψһʵʾ,NULLʱͨcert_entity_lenȡ
 *           cert_entity_len [IN/OUT] ʱ(cert_entityΪNULL)ʾǩֵĻ
 *                                    ʱʾǩֵĳ
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_GetCertEntity(sof_ctx_t *sctx, kuchar *user_cert, uint32 uc_len, 
							  uchar *outd, uint32 *outd_len);

/***************************************************
 *  SOF_ValidateCert
 * ˵: ֤֤Ч
 * ˵: 
 *           user_cert     [IN] der֤
 *           user_cert_len [IN] ֤鳤
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_ValidateCert(sof_ctx_t *sctx, kuchar *user_cert, uint32 uc_len,uint32 *out_ret);

/*
 * hash alg type
 */
enum {
	// ժҪ㷨
	e_alg_sm3    = 0x00000001,
	e_alg_sha1   = 0x00000002,
	e_alg_sha256 = 0x00000004,
	e_alg_md5    = 0x00000008,
	e_alg_sha384 = 0x00000010,
	e_alg_sha512 = 0x00000020,
	e_alg_md5_sha1 = 0x00000040
};

/***************************************************
 *  SOF_SignData
 * ˵: ݽǩ
 * ˵: certid        [IN]     ֤ID,'\0'β
 *           ind           [IN]     ǩԭ
 *           ind_len       [IN]     ǩԭݳ
 *           signature     [OUT]    ǩֵ,NULLʱͨsignature_lenȡ
 *           signature_len [IN/OUT] ʱ(signatureΪNULL)ʾǩֵĻ
 *                                  ʱʾǩֵĳ
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_SignData(sof_ctx_t *sctx, kchar *certid, 
                         kuchar *ind, uint32 ind_len, 
				         uchar *sig, uint32 *o_len);

/***************************************************
 *  SOF_VerifySignedData
 * ˵: ݽǩ
 * ˵: user_cert     [IN] Der֤
 *           user_cert_len [IN] Der֤鳤
 *           ind           [IN] ǩԭ
 *           ind_len       [IN] ǩԭݳ
 *           signature     [IN] ǩֵ
 *           signature_len [IN] ǩֵĳ
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_VerifySignedData(sof_ctx_t *sctx, uchar *user_cert, uint32 uc_len, 
								 kuchar *ind, uint32 ind_len, 
								 kuchar *sig, uint32 sig_len);

/***************************************************
 *  SOF_SignHashData
 * ˵: ݽǩ
 * ˵: certid        [IN]     ֤ID,'\0'β
 *           ind           [IN]     ǩHash
 *           ind_len       [IN]     ǩHashݳ
 *           hash_alg      [IN]     Hash㷨
 *           signature     [OUT]    ǩֵ,NULLʱͨsignature_lenȡ
 *           signature_len [IN/OUT] ʱ(signatureΪNULL)ʾǩֵĻ
 *                                  ʱʾǩֵĳ
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_SignHashData(sof_ctx_t *sctx, kchar *certid, 
							 kuchar *ind, uint32 ind_len, 
							 uint32 hash_alg,
							 uchar *sig, uint32 *o_len);

/***************************************************
 *  SOF_VerifySignedHashData
 * ˵: ݽǩ
 * ˵: user_cert     [IN] Der֤
 *           user_cert_len [IN] Der֤鳤
 *           ind           [IN] ǩԭ
 *           ind_len       [IN] ǩԭݳ
 *           hash_alg      [IN] Hash㷨
 *           signature     [IN] ǩֵ
 *           signature_len [IN] ǩֵĳ
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_VerifySignedHashData(sof_ctx_t *sctx, uchar *user_cert, uint32 uc_len, 
									 kuchar *ind, uint32 ind_len, uint32 hash_alg, 
									 kuchar *sig, uint32 sig_len);


/***************************************************
 *  SOF_SignMessage
 * ˵: ݽPKCS7ǩ
 * ˵: certid        [IN]     ֤ID,'\0'β
 *           dwFlag        [IN]     0ʱΪAttached 1ʱΪDetached
 *           ind           [IN]     ǩԭ
 *           ind_len       [IN]     ǩԭݳ
 *           signature     [OUT]    PKCS7ǩֵ,NULLʱͨsignature_lenȡ
 *           signature_len [IN/OUT] ʱ(signatureΪNULL)ʾǩֵĻ
 *                                  ʱʾǩֵĳ
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_SignMessage(sof_ctx_t *sctx, kchar *CertID,  int dwFlag, kuchar *ind, 
							uint32 ind_len,uchar *outd, uint32 *outd_len);

/***************************************************
 *  SOF_VerifySignedMessage
 * ˵: ݽǩ
 * ˵: signature     [IN] PKCS7ǩֵ
 *           signature_len [IN] PKCS7ǩֵĳ
 *           ind           [IN] ǩԭ(ǩΪDetachedʱЧ)
 *           ind_len       [IN] ǩԭݳ(ǩΪDetachedʱЧ)
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_VerifySignedMessage(sof_ctx_t *sctx, kuchar *p7_data, uint32 p7_len,
									kuchar *ind, uint32 ind_len);

/***************************************************
 *  SOF_EncryptData
 * ˵: ŷ
 * ˵: user_cert     [IN]     Der֤
 *           user_cert_len [IN]     Der֤鳤
 *           ind           [IN]     ܵ
 *           ind_len       [IN]     ܵݳ
 *           outd          [OUT]     ݵĻ,NULLʱͨoutd_len
 *           outd_len      [IN/OUT] ʱ(outdΪNULL)ʾĵĻ
 *                                  ʱʾĵĳ
 * ֵ: 0ɹ 0ʧ 
 * ע:ӿڼܵ SecXܽ
 ***************************************************/
int SOF_API SOF_EncryptData(sof_ctx_t *sctx, uchar *user_cert, uint32 user_cert_len, 
							kuchar *ind, uint32 ind_len, 
							uchar *outd, uint32 *outd_len);

/***************************************************
 *  SOF_DecryptData
 * ˵: ŷ
 * ˵: certid        [IN]     ֤ID,'\0'β
 *           ind           [IN]     ܵ
 *           ind_len       [IN]     ܵݳ
 *           outd          [OUT]     սܺݵĻ,NULLʱͨoutd_len
 *           outd_len      [IN/OUT] ʱ(outdΪNULL)ʾĵĻ
 *                                  ʱʾĵĳ
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_DecryptData(sof_ctx_t *sctx, kchar *certid, kuchar *ind, 
							uint32 ind_len, uchar *outd, uint32 *outd_len);


/***************************************************
 *  SOF_PubKeyEncrypt
 * ˵: ֤еĹԿм
 * ˵: user_cert     [IN]     Der֤
 *           user_cert_len [IN]     Der֤鳤
 *           ind           [IN]     ܵ
 *           ind_len       [IN]     ܵݳ
 *           outd          [OUT]    ݵĻ,NULLʱͨoutd_len
 *           outd_len      [IN/OUT] ʱ(outdΪNULL)ʾĵĻ
 *                                  ʱʾĵĳ
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_PubKeyEncrypt(sof_ctx_t *sctx, kuchar *user_cert, uint32 user_cert_len, 
							  kuchar *ind, uint32 ind_len, 
							  uchar *outd, uint32 *outd_len);

/***************************************************
 *  SOF_PriKeyDecrypt
 * ˵: ŷ
 * ˵: certid        [IN]     ֤ID,'\0'β
 *           ind           [IN]     ܵ
 *           ind_len       [IN]     ܵݳ
 *           outd          [OUT]    սܺݵĻ,NULLʱͨoutd_len
 *           outd_len      [IN/OUT] ʱ(outdΪNULL)ʾĵĻ
 *                                  ʱʾĵĳ
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_PriKeyDecrypt(sof_ctx_t *sctx, kchar *certid, 
							  kuchar *ind, uint32 ind_len, 
							  uchar *outd, uint32 *outd_len);

/***************************************************
 *  SOF_SymEncryptData
 * ˵: ԳƼ
 * ˵: key      [IN]     ԳԿ
 *           key_len  [IN]     ԳԿĳ
 *           ind      [IN]     ܵ
 *           ind_len  [IN]     ܵݳ
 *           outd     [OUT]    ݵĻ,NULLʱͨoutd_len
 *           outd_len [IN/OUT] ʱ(outdΪNULL)ʾĵĻ
 *                             ʱʾĵĳ
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_SymEncryptData(sof_ctx_t *sctx, kuchar *key, uint32 key_len, 
							   kuchar *ind, uint32 ind_len, 
							   uchar *outd, uint32 *outd_len);

/***************************************************
 *  SOF_SymDecryptData
 * ˵: Գƽ
 * ˵: key      [IN]     ԳԿ
 *           key_len  [IN]     ԳԿĳ
 *           ind      [IN]     ܵ
 *           ind_len  [IN]     ܵݳ
 *           outd     [OUT]    սܺݵĻ,NULLʱͨoutd_len
 *           outd_len [IN/OUT] ʱ(outdΪNULL)ʾĵĻ
 *                             ʱ(outdΪNULL)ʾĵĳ
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_SymDecryptData(sof_ctx_t *sctx, kuchar *key, uint32 key_len, 
							   kuchar *ind, uint32 ind_len, 
							   uchar *outd, uint32 *outd_len);


/***************************************************
 *  SOF_GenRandom
 * ˵: 
 * ˵: rnd_len [IN]  Ҫ
 *           rnd     [OUT] 
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_GenRandom(sof_ctx_t *sctx, uint32 rnd_len, kuchar *rnd);


/***************************************************
 *  SOF_HashData
 * ˵: ժҪ
 * ˵: hash_algo [IN]     ժҪ㷨
 *           ind       [IN]     
 *           ind_len   [IN]     ݵĳ
 *           cert      [IN]     ժҪ(ǩ)֤Կ
 *           cert_len  [IN]     ժҪ(ǩ)֤Կ
 *           id        [IN]     ժҪ(ǩ)ID
 *           id_len    [IN]     ժҪ(ǩ)ID
 *           outd      [OUT]    ժҪ,NULLʱͨoutd_lenس
 *           outd_len  [IN/OUT] ʱ(outdΪNULL)ʾժҪݵĻ
 *                              ʱʾժҪݳ
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_HashData(sof_ctx_t *sctx, uint32 hash_algo, kuchar *ind, uint32 ind_len, 
						 kuchar *cert, uint32 cert_len, kuchar *id, uint32 id_len, 
						 uchar *outd, uint32 *outd_len);

/***************************************************
 *  SOF_HashFile
 * ˵: ļժҪ
 * ˵: hash_algo [IN]     ժҪ㷨
 *           inf       [IN]     ժҪļȫ·,'\0'β
 *           cert      [IN]     ժҪ(ǩ)֤Կ
 *           cert_len  [IN]     ժҪ(ǩ)֤Կ
 *           id        [IN]     ժҪ(ǩ)ID
 *           id_len    [IN]     ժҪ(ǩ)ID
 *           outd      [OUT]    ժҪ,NULLʱͨoutd_lenس
 *           outd_len  [IN/OUT] ʱ(outdΪNULL)ʾժҪݵĻ
 *                              ʱʾժҪݳ
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_HashFile(sof_ctx_t *sctx, uint32 hash_algo, kchar *inf, 
						 kuchar *cert, uint32 cert_len, kuchar *id, uint32 id_len, 
						 uchar *outd, uint32 *outd_len);

/***************************************************
 *  SOF_Base64Encode
 * ˵: Base64
 * ˵: ind      [IN]     ԭ
 *           ind_len  [IN]     ԭݵĳ
 *           outd     [OUT]    ,NULLʱͨoutd_lenس
 *           outd_len [IN/OUT] ʱ(outdΪNULL)ʾݵĻ
 *                             ʱʾݳ
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_Base64Encode(sof_ctx_t *sctx, const kuchar *ind, uint32 ind_len, kuchar *outd, uint32 *outd_len);

/***************************************************
 *  SOF_Base64Decode
 * ˵: Base64
 * ˵: ind      [IN]     Base64
 *           ind_len  [IN]     Base64ݳ
 *           outd     [OUT]    ,NULLʱͨoutd_lenس
 *           outd_len [IN/OUT] ʱ(outdΪNULL)ʾݵĻ
 *                             ʱʾݳ
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_Base64Decode(sof_ctx_t *sctx, const kuchar *ind, uint32 ind_len, kuchar *outd, uint32 *outd_len);

/***************************************************
 *  Base64EncodeFile
 * ˵: ļBase64
 * ˵: inf            [IN]     ļȫ·,'\0'β
 *           coded_data     [OUT]    ǰļBase64,'\0'β,NULLʱͨcoded_data_lenȡ
 *           coded_data_len [IN/OUT] ʱ(coded_dataΪNULL)ʾݵĻ
 *                                   ʱʾBase64ݵĳ,'\0'
 * ֵ: 0ɹ 0ʧ 
 * ע  
 ***************************************************/
int SOF_API Base64EncodeFile(sof_ctx_t *sctx, const kuchar *inf, kuchar *outd, uint32 *outd_len);

 
/***************************************************
 *  Base64Decode2File
 * ˵: ݽ󱣴浽ļ
 * ˵: inf            [IN]    ļȫ·,'\0'β
 *           coded_data     [IN]    
 *           coded_data_len [IN]	ݳ 
 * ֵ: 0ɹ 0ʧ 
 * ע  
 ***************************************************/
int SOF_API Base64Decode2File(sof_ctx_t *sctx, const kuchar *ind, uint32 ind_len,const kuchar *inf);

enum { 
	// ȡ豸Ϣ
	e_Label              = 1,    // 豸ǩ
	e_FreeSpace          = 2,    // ʣռ
	e_SerialNumber       = 3,    // 豸к
	e_DeviceType         = 4,    // 豸
	e_userPinRetryCount  = 5,    // ûԴ
	e_adminPinRetryCount = 6,    // ԱԴ
	e_deviceType2        = 7,    // 豸 Ӳ豸HARD 豸SOFT
	e_devicepridll       = 8,    // ضӦչ
	e_deviceprovider     = 9,    // CSP

	e_TotalSpace             = 10, // 豸ܿռ
	e_userPinTotalRetryCount = 11, // ûPINԴ
	e_oldContainerName       = 12, // ǰɵ
	e_driverVersion          = 13, // ȫ·Ͱ汾
	e_SymAlgCap              = 14, // ֵ֧ķ㷨
	e_AsymAlgCap             = 15, // ֵ֧ķǶԳ㷨
	e_deviceType3            = 16, // 豸 SOFTUSBKEYICCARD
	e_support_pki            = 17, // Ƿ֧PKIӦ(ھ񽡿Ͽ)
	e_rhcard_userinfo        = 18, // ھ񽡿ûϢ &&&֤&&&绰&&&
	e_HashAlgCap             = 19, // ֵ֧ժҪ㷨

	e_KeyType      = 0x73, // 豸 RSA 10 SM2豸20 ϵBJCASAC ֤ҳõ
	e_vid_pid      = 0x74, // 豸VID  PIDϵBJCASAC ֤ҳõ
	e_providertype = 0x75, // 豸 SKFBJCAKeyCSPCSP11Soft

	// 豸
	e_device_type_soft     = 1,  // ֤
	e_device_type_usbkey   = 2,  // USBKey豸
	e_device_type_iccard   = 3,  // IC豸
	e_device_type_mhcard   = 4,  // 񽡿(ҲIC еĿ֧PKIӦ)
	e_device_type_otpkey   = 5,  // OTP+KEY豸
	e_device_type_cloudkey = 6
};

enum {
        // û
        e_admin = 0,
        e_user = 1,

        // Ȩ
        e_puser  = 0x10,
        e_padmin = 0x01,
        e_pnone  = 0x00,
        e_pany   = 0x0ff,

        // PINУ
        e_pintype_password = 1,
        e_pintype_finger = 2,
        e_pintype_otp = 3
    };

enum {
	//Կ
	e_key_sign = 1, // ǩ
	e_key_enc  = 0, // 
};

enum {
	//ȡ֤Ϣ
	e_cert_not_after = 12,
};

// Գ㷨Ϣṹ
typedef struct SymAlgInfo {
	uint32 ulAlgId_;
	int    nid_;
	uint32 ulKeyLen_;
	uint32 ulIVLen_;
}SymAlgInfo;

/***************************************************
 *  GetDeviceCount
 * ˵: ȡ豸
 * ˵: dev_count [OUT] 豸
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API GetDeviceCount(sof_ctx_t *sctx,uint32 *len);

/***************************************************
 *  GetDeviceCountEx
 * ˵: ȡ豸
 * ˵: type      [IN]  ȡ 1 Ӳ豸 2豸 3ȫ豸
 *           dev_count [OUT] 豸
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API GetDeviceCountEx(sof_ctx_t *sctx, uint32 type, uint32 *dev_count);

/***************************************************
 *  GetAllDeviceSN
 * ˵: ȡ豸к
 * ˵: dev_sn     [OUT]    豸к,'\0'β,NULLʱͨdev_sn_lenȡ 
 *                                devsn1;devsn2;...
 *           dev_sn_len [IN/OUT] ʱ(dev_snΪNULL)ʾ豸кŵĻ
 *                               ʱʾ豸кŵĳ,'\0'
 * ֵ: 0ɹ 0ʧ 
 * 
 ***************************************************/
int SOF_API  GetAllDeviceSN(sof_ctx_t *sctx,uchar *AllDeviceSN,uint32 *sn_count);

/***************************************************
 *  GetAllDeviceSNEx
 * ˵: ȡ豸к
 * ˵: type       [IN]     ȡ 1 Ӳ豸 2豸 3ȫ豸
 *           dev_sn     [OUT]    豸к,'\0'β,NULLʱͨdev_sn_lenȡ 
 *                                devsn1;devsn2;...
 *           dev_sn_len [IN/OUT] ʱ(dev_snΪNULL)ʾ豸кŵĻ
 *                               ʱʾ豸кŵĳ,'\0'
 * ֵ: 0ɹ 0ʧ 
 * ע 
 ***************************************************/
int SOF_API GetAllDeviceSNEx(sof_ctx_t *sctx, uint32 type, uchar *dev_sn, uint32 *dev_sn_len);

/***************************************************
 *  GetDeviceSNByIndex
 * ˵: ȡ豸к
 * ˵: index     [IN]       0ʼ
 *           dev_sn     [OUT]    豸к,'\0'β,NULLʱͨdev_sn_lenȡ
 *           dev_sn_len [IN/OUT] ʱ(dev_snΪNULL)ʾ豸кŵĻ
 *                               ʱʾ豸кŵĳ,'\0'
 * ֵ: 0ɹ 0ʧ 
 * ע 
 ***************************************************/
int SOF_API GetDeviceSNByIndex(sof_ctx_t *sctx, uint32 index, char *dev_sn, uint32 *dev_sn_len);

/***************************************************
 *  IsDeviceExist
 * ˵: ж豸Ƿ
 * ˵: dev_sn   [IN]  豸к,'\0'β
 *           pres     [OUT] ڷ1 ڷ0 
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API IsDeviceExist(sof_ctx_t *sctx, kchar *dev_sn, uint32 *pres);

/***************************************************
 *  GetDeviceInfo
 * ˵: ȡ豸ϸϢ
 * ˵: dev_sn   IN]      豸к,'\0'β
 *           type     [IN]     Ϣ
 *           info     [OUT]    Ϣ,'\0'β,NULLʱͨoutd_lenȡ
 *           info_len [IN/OUT] ʱ(infoΪNULL)ʾϢĻ
 *                             ʱʾϢĳ,'\0'
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API GetDeviceInfo(sof_ctx_t *sctx, kchar *dev_sn, uint32 type, char *info, uint32 *info_len);

/***************************************************
 *  ChangeAdminPass
 * ˵: ޸ĹԱ
 * ˵: dev_sn   [IN] 豸к,'\0'β
 *           old_pass [IN] ɹԱ,'\0'β
 *           new_pass [IN] ¹Ա,'\0'β
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API ChangeAdminPass(sof_ctx_t *sctx,uchar * sDeviceSN, uchar * sOldPass, uchar * sNewPass);

/***************************************************
 *  UnlockUserPass
 * ˵: û
 * ˵: dev_sn        [IN] 豸к,'\0'β
 *           admin_pass    [IN] Ա,'\0'β
 *           new_user_pass [IN] û,'\0'β
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API UnlockUserPass(sof_ctx_t *sctx, kchar *dev_sn, kchar *admin_pass, kchar *new_user_pass);

/***************************************************
 *  UnlockUserPassEx
 * ˵: û
 * ˵: dev_sn        [IN] 豸к,'\0'β
 *           admin_pass    [IN] Ա,'\0'β
 *           new_user_pass [IN] û,'\0'β
 * ֵ: 0ɹ 0ʧ 
 * ˵sNewUserPass Ǳû base64,Ȼ,
 *			base64ǰΪ 6~16 λ ȡֵΧ 0x20  0x7e
 ***************************************************/
int SOF_API UnlockUserPassEx(sof_ctx_t *sctx,uchar * sDeviceSN, uchar * sAdminPass, uchar * sNewUserPass);

/***************************************************
 *  GenerateKeyPair
 * ˵: Կ
 * ˵: dev_sn   [IN] 豸к,'\0'β
 *           con_name [IN] ,'\0'β
 *           keytype  [IN] Կ 1:RSA-1024 2:RSA-2048 3:SM2-256
 *           bsign    [IN] Կλ 1:ǩ 0:
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API GenerateKeyPair(sof_ctx_t *sctx,uchar * sDeviceSN,uchar * sContainerName);

/***************************************************
 *  ExportPubKey
 * ˵: Կ
 * ˵: dev_sn         [IN]     豸к,'\0'β
 *           con_name       [IN]     ,'\0'β
 *           bsign          [IN]     Կλ 1:ǩ 0:
 *           der_pubkey     [OUT]    ԿDer,NULLʱͨder_pubkey_lenȡ
 *           der_pubkey_len [IN/OUT] ʱ(der_pubkeyΪNULL)ʾչԿĻ
 *                                   ʱʾԿĳ
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API ExportPubKey(sof_ctx_t *sctx, kchar *dev_sn, kchar *con_name, 
						 uint32 bsign, uchar *der_pubkey, uint32 *der_pubkey_len);

/***************************************************
 *  ExportPKCS10
 * ˵: PKCS10֤
 * ˵: dev_sn      [IN]     豸к,'\0'β
 *           con_name    [IN]     ,'\0'β
 *           bsign       [IN]     Կλ 1:ǩ 0:
 *           dn          [IN]     DN,'\0'β
 *                                "CN=name, OU=BJCA R&D, O=BJCA, L=\\,, ST=bj, C=CN, E=mail@bjca.com,"
 *                                DNж(,)ǰ߼\ת
 *           der_p10     [OUT]    DerP10,NULLʱͨder_p10_lenȡ
 *           der_p10_len [IN/OUT] ʱ(der_pubkeyΪNULL)ʾP10Ļ
 *                                ʱʾP10ĳ
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API ExportPKCS10(sof_ctx_t *sctx, kchar *dev_sn, kchar *con_name, 
						 uint32 bsign, kchar *dn, uchar *der_p10, uint32 *der_p10_len);

/***************************************************
 *  ImportSignCert
 * ˵: ǩ֤
 * ˵: dev_sn        [IN] 豸к,'\0'β
 *           con_name      [IN] ,'\0'β
 *           user_cert     [IN] Derǩ֤
 *           user_cert_len [IN] Derǩ֤鳤
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API ImportSignCert(sof_ctx_t *sctx, kchar *dev_sn, kchar *con_name, uchar *user_cert, uint32 user_cert_len);

/***************************************************
 *  ImportEncCert
 * ˵: ֤ͼԿ
 * ˵: dev_sn            [IN] 豸к,'\0'β
 *           con_name          [IN] ,'\0'β
 *           user_cert         [IN] Derǩ֤
 *           user_cert_len     [IN] Derǩ֤鳤
 *           cipher_prikey     [IN] ԿԵ
 *           cipher_prikey_len [IN] ԿԵĳ
 *           sym_algo          [IN] Գ㷨
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API ImportEncCert(sof_ctx_t *sctx, kchar *dev_sn, kchar *con_name, 
						  kuchar *user_cert, uint32 user_cert_len, 
						  kuchar *cipher_prikey, uint32 cipher_prikey_len, uint32 sym_algo);

/***************************************************
 *  EnumFilesInDevice
 * ˵: ö豸ڵļ
 * ˵: dev_sn     [IN]  豸к,'\0'β
 *           files      [OUT]    ļ м&&&ָ 緵 file1&&&file2&&&....filen&&&
 *                               NULL ͨfiles_lenس
 *           files_len  [IN/OUT] ʱ(filesΪNULL)ʾļƵĻ
 *                               ʱʾļƵĳ,'\0'
 * ֵ: 0ɹ 0ʧ 
 * 
 ***************************************************/
int SOF_API EnumFilesInDevice(sof_ctx_t *sctx, kchar *dev_sn,
							  char *files, uint32 *files_len);

/***************************************************
 *  SOF_ReadFile
 * ˵: 豸жȡļ
 * ˵: dev_sn           [IN]     豸к,'\0'β
 *           file_name        [IN]     ļ,'\0'β
 *           file_content     [OUT]    ļ,NULLʱͨfile_content_lenȡ 
 *           file_content_len [IN/OUT] ʱ(file_contentΪNULL)ʾļݵĻ
 *                                     ʱʾļݵĳ
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_ReadFile(sof_ctx_t *sctx,uchar * sDeviceSN, uchar  *file_name, 
						 uchar *ind, uint32 *ind_len);

/***************************************************
 *  SOF_WriteFile
 * ˵: ļд뵽豸
 * ˵: dev_sn           [IN] 豸к,'\0'β
 *           file_name        [IN] ļ,'\0'β
 *           file_content     [IN] ļ
 *           file_content_len [IN] ļݵĳ
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_WriteFile(sof_ctx_t *sctx, kchar *dev_sn, kchar *file_name, 
						  kuchar *file_content, uint32 file_content_len);

/***************************************************
 *  SOF_WriteFileEx
 * ˵: ļд뵽豸
 * ˵: dev_sn           [IN] 豸к,'\0'β
 *           file_name         [IN] ļ,'\0'β
 *           file_content      [IN] ļ
 *           file_content_len  [IN] ļݵĳ
 *           bPrivate          [IN] Ƿд˽
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SOF_WriteFileEx(sof_ctx_t *sctx, kchar *dev_sn, kchar *file_name, 
							kuchar *file_content, uint32 file_content_len, int bPrivate);

/***************************************************
 *  GetContainerCount
 * ˵: ȡ豸е
 * ˵: dev_sn    [IN]  豸к,'\0'β
 *           con_count [OUT]  
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API GetContainerCount(sof_ctx_t *sctx, kchar *dev_sn, uint32 *con_count);

/***************************************************
 *  SOF_GetAllContainerName
 * ˵: ȡ豸
 * ˵: dev_sn            [IN]    豸к,'\0'β
 *           all_con_name      [OUT]   ,'\0'β,NULLʱͨall_con_name_lenȡ 
 *                                      container1&&&container2&&&...
 *           all_con_name_len [IN/OUT] ʱ(outdΪNULL)ʾĻ
 *                                     ʱʾĳ,'\0'
 * ֵ: 0ɹ 0ʧ 
 * ע 
 ***************************************************/
int SOF_API SOF_GetAllContainerName(sof_ctx_t *sctx, kchar *dev_sn, char *all_con_name, uint32 *all_con_name_len);

/***************************************************
 *  IsContainerExist
 * ˵: жǷ
 * ˵: dev_sn   [IN]  豸к,'\0'β
 *           con_name [IN]  ,'\0'β
 *           pres     [OUT] ڷ1 ڷ0 
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API IsContainerExist(sof_ctx_t *sctx, kchar *dev_sn, kchar *con_name, uint32 *pres);

/***************************************************
 *  DeleteContainer
 * ˵: ɾ
 * ˵: dev_sn   [IN]  豸к,'\0'β
 *           con_name [IN]  ,'\0'β
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API DeleteContainer(sof_ctx_t *sctx, kchar *dev_sn, kchar *con_name);

/***************************************************
 *  DeleteOldContainer
 * ˵: ɾ豸ɵ
 * ˵: dev_sn    [IN]  豸к,'\0'β
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API DeleteOldContainer(sof_ctx_t *sctx, kchar *dev_sn);

/***************************************************
 *  InitDevice
 * ˵: ʽ豸
 * ˵: dev_sn     [IN]  豸к,'\0'β
 *           admin_pass [IN]  Ա,'\0'β
 *           user_pass  [IN]  û,'\0'β
 *           key_label  [IN]  ǩ,'\0'β
 *           admin_maxretry  [IN]  ԱԴ
 *           user_maxretry   [IN]  ûԴ
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API InitDevice(sof_ctx_t *sctx, kchar *dev_sn, kchar *admin_pass);

int SOF_API InitDeviceEx(sof_ctx_t *sctx, kchar *dev_sn, kchar *admin_pass, 
						 kchar *user_pass, kchar *key_label, uint32 admin_maxretry, uint32 user_maxretry);

/***************************************************
 *  GetENVSN
 * ˵: ȡǰõ
 * ˵: dev_sn    [IN]     豸к,'\0'β
 *           envsn     [OUT]    ǰõ,'\0'β,NULLʱͨenvsn_lenȡ
 *           envsn_len [IN/OUT] ʱ(envsnΪNULL)ʾĻ
 *                              ʱʾĳ,'\0'
 * ֵ: 0ɹ 0ʧ 
 * ע 
 ***************************************************/
int SOF_API GetENVSN(sof_ctx_t *sctx, kchar *dev_sn, char *envsn, uint32 *envsn_len);

/***************************************************
 *  SetENVSN
 * ˵: õǰõ
 * ˵: dev_sn  [IN]  豸к,'\0'β
 *           envsn   [IN]  ,'\0'β
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SetENVSN(sof_ctx_t *sctx, kchar *dev_sn, kchar *envsn);

/***************************************************
 *  SetUserConfig
 * ˵: ûϢ
 * ˵: type   [IN]    4 ʾûŵ base64CA ֤
 *									5 ʾûŵ base64CRL
 *									6 ʾ base64P7B ֤
 *           config [IN] õĲ,'\0'β 
 *                               
 * ֵ: 0ɹ 0ʧ 
 ***************************************************/
int SOF_API SetUserConfig(sof_ctx_t *sctx, uint32 type, kchar *config);


/**************************************************
EnumESeal
?sDeviceSN  [IN} \0
          outd       [OUT] json?          outd_len   [IN,OUT] json?***************************************************/
//int SOF_API EnumESeal(sof_ctx_t *sctx,kchar* sDeviceSN,char *outd, uint32 *outd_len);
int SOF_API SOF_ImportSymmKey(sof_ctx_t *sctx, char* certid, uint32 ulKeyIndex, kuchar* inData, uint32 inLen,uint32 ulFlags);
int SOF_API SOF_EPS_ReadESealData(sof_ctx_t *sctx, char* certid,uint32 ulKeyIndex, uint32 ulKeyAlgId,uchar* pbOutData,uint32 *outLen,uint32 ulFlags);
int SOF_API SOF_WriteESealData(sof_ctx_t *sctx, char* certid, kuchar* inData, uint32 inLen,uint32 ulFlags);
int SOF_API SOF_EPS_Encrypt(sof_ctx_t *sctx, char* CertID, int ulKeyIndex, int ulKeyAlgId, kuchar* pbIVData, int ivDataLen, int DivCount, kuchar* pbDivComponent, int divComponentLen, kuchar* pbInData, int inDataLen, uchar* upbEPSEncrypt, int *EPSEncryptLen, int ulFlags);
int SOF_API SOF_EPS_Decrypt(sof_ctx_t *sctx, char* CertID, int ulKeyIndex, int ulKeyAlgId, kuchar* pbIVData, int ivDataLen, int DivCount, kuchar* pbDivComponent, int divComponentLen, kuchar* pbInData, int inDataLen, uchar* pbEPSDecrypt, int *EPSDecryptLen, int ulFlags);
int SOF_API SOF_EPS_Mac(sof_ctx_t *sctx, char* CertID, int ulKeyIndex, int ulKeyAlgId, kuchar* pbIVData, int ivDataLen, int DivCount, kuchar* pbDivComponent, int divComponentLen, kuchar* pbInData, int inDataLen, uchar* pbEPSMac, int *EPSMacLen, int ulFlags);
#ifdef __cplusplus
}
#endif

#endif // ifndef _XTXAPP_C_UTIL_H_

